#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	N2		1000		//the number of Trial

dsfmt_t dsfmt1;				//random number


double rand_cauchy(double x0 , double gamma){	//rand: cauchy
	double x = dsfmt_genrand_close_open(&dsfmt1);
	double y = x0 + gamma * tan( M_PI * (x - 0.5) );
	return y;
}


int double_comp(const void *_a, const void *_b) {	//for qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}


int main( int argc , char *argv[] ){
	
	
	int i, j;
	double *rand;
	double med , sum , sum2;
	double V_data , V_theory;
	int x;
	int N1;		//Number of random number 
	double gamma = atof(argv[1]);
	
	FILE *fp;
	char *fn;
	fn = (char *)calloc( 100 , sizeof(char) );
	sprintf( fn , "output_%s.dat", argv[1] );
	
	if( (fp=fopen( fn ,"w")) ==NULL){
		printf("FILE Error\n");
		exit(1);
	}
	
	
	for( x = 20  ; x <= 50 ; x+=2 ){		
		N1 = (int)pow(10, x/10.0 );						//N1 =  "n" in the book
		
		rand = (double *)calloc( N1 , sizeof(double) );
		sum = 0.0;
		sum2 = 0.0;
		
		for( i=0; i<N2 ; i++){	//trial
			
			//Seed of random number
			dsfmt_init_gen_rand(&dsfmt1,i);
			
			for( j=0; j<N1; j++){	//generate the random number
				rand[j] = rand_cauchy(0.0 ,gamma);
			}
			
			
			qsort( rand , N1 ,sizeof(double),double_comp);
			med = ( rand[(N1/2)-1] + rand[(N1/2)] )/2.0;
			
			sum += med;
			sum2 += med * med;
		}
		V_data = sum2/N2 - pow(sum/N2,2.0);
		V_theory = (4.0 * gamma * gamma )/(M_PI*M_PI * (N1+2));
		
		fprintf(fp,"%d	%f	%f	%f\n", N1 ,V_data,V_theory , V_data/V_theory );
		
		printf("finish %1.1f	%d\n",gamma ,N1);
		
		free(rand);
	}
	
	fclose(fp);
	free(fn);
	
	return 0;
}



