#!/bin/bash

gcc -o 	problem3_5_5_3.exe 	problem3_5_5_3.c 	dSFMT.c

./problem3_5_5_3.exe	1.0		&
./problem3_5_5_3.exe	2.0		&
./problem3_5_5_3.exe	3.0

wait 

gnuplot <<EOF
set terminal postscript eps enhanced color
set output "output.eps"
set size 0.6 , 0.6 
set xlabel "n"
set ylabel "{/Symbol s}_{x_{1/2}}"
set log xy
set format x "10^{%L}"
set format y "10^{%L}"
plot 	"output_1.0.dat" u 1:2 title "{/Symbol g}=1.0" w p  pt 7 lc rgb "red" ,\
		"output_2.0.dat" u 1:2 title "{/Symbol g}=2.0" w p  pt 7 lc rgb "blue" ,\
		"output_3.0.dat" u 1:2 title "{/Symbol g}=3.0" w p  pt 7 lc rgb "dark-green" ,\
		2.5*(x+2)**-1 title "2.5(n+2)^{-1}"  lt 2 lc rgb "pink" ,\
		10*(x+2)**-1 title "10.0(n+2)^{-1}"  lt 2 lc rgb "cyan",\
		22.5*(x+2)**-1 title "22.5(n+2)^{-1}"  lt 2 lc rgb "green"
EOF


